> ## Documentation Index
> Fetch the complete documentation index at: https://doc.extole.com/llms.txt
> Use this file to discover all available pages before exploring further.

# List built triggers on a controller

> Returns all triggers on the controller in their fully evaluated runtime form.



## OpenAPI

````yaml /api-reference/management-expert.json get /v2/campaigns/{campaignId}{version}/controllers/{controllerId}/triggers/built
openapi: 3.0.1
info:
  description: >-
    Advanced configuration endpoints for Extole platform experts: campaign
    controllers, typed actions and triggers, advanced component types and
    facets, source mapping, report post-handlers, pre-handlers, and other expert
    configuration surfaces not included in the standard Management API.
  title: Management Expert API
  version: '1.0'
servers:
  - description: Production
    url: https://api.extole.io
security:
  - HEADER: []
  - QUERY: []
  - COOKIE: []
tags:
  - name: Authentication
  - name: Campaign Controllers
  - name: Campaign Controllers Actions
  - name: Campaign Controllers Triggers
  - name: Campaign Flow Steps
  - name: Components
  - name: Components Grants
  - name: Components Subscriptions
  - name: Components Types
  - name: Content
  - name: Debug
  - name: Domains
  - name: Email
  - name: Event Prehandlers
  - name: Events
  - name: Javascript Core Extensions
  - name: Persons
  - name: Profiles
  - name: Report Schedules
  - name: Report Types
  - name: Reporting
  - name: Security Keys
  - name: Settings
paths:
  /v2/campaigns/{campaignId}{version}/controllers/{controllerId}/triggers/built:
    get:
      tags:
        - Campaign Controllers Triggers
      summary: List built triggers on a controller
      description: >-
        Returns all triggers on the controller in their fully evaluated runtime
        form.
      operationId: listBuiltCampaignControllerTriggers
      parameters:
        - in: path
          name: campaignId
          required: true
          schema:
            type: string
        - in: path
          name: version
          required: true
          schema:
            pattern: (/version/.+)?
            type: string
        - in: path
          name: controllerId
          required: true
          schema:
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                items:
                  $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponse'
                type: array
          description: Successful response
        '400':
          content:
            application/json:
              examples:
                binding_error:
                  $ref: '#/components/examples/binding_error'
                campaign_build_failed:
                  $ref: '#/components/examples/campaign_build_failed'
                campaign_concurrent_update:
                  $ref: '#/components/examples/campaign_concurrent_update'
                campaign_has_pending_changes:
                  $ref: '#/components/examples/campaign_has_pending_changes'
                campaign_locked:
                  $ref: '#/components/examples/campaign_locked'
                campaign_version_malformed:
                  $ref: '#/components/examples/campaign_version_malformed'
                controller_state_misconfiguration:
                  $ref: '#/components/examples/controller_state_misconfiguration'
                date_invalid:
                  $ref: '#/components/examples/date_invalid'
                expression_invalid_syntax:
                  $ref: '#/components/examples/expression_invalid_syntax'
                invalid_campaign_id:
                  $ref: '#/components/examples/invalid_campaign_id'
                invalid_campaign_state:
                  $ref: '#/components/examples/invalid_campaign_state'
                invalid_campaign_version:
                  $ref: '#/components/examples/invalid_campaign_version'
                invalid_json:
                  $ref: '#/components/examples/invalid_json'
                invalid_parameter:
                  $ref: '#/components/examples/invalid_parameter'
                lock_missing_lock_types:
                  $ref: '#/components/examples/lock_missing_lock_types'
                missing_request_body:
                  $ref: '#/components/examples/missing_request_body'
                rebuild_campaigns_build_failed:
                  $ref: '#/components/examples/rebuild_campaigns_build_failed'
                unlock_missing_lock_types:
                  $ref: '#/components/examples/unlock_missing_lock_types'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Bad Request
        '401':
          content:
            application/json:
              examples:
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unauthorized
        '402':
          content:
            application/json:
              examples:
                payment_required:
                  $ref: '#/components/examples/payment_required'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Payment Required
        '403':
          content:
            application/json:
              examples:
                access_denied:
                  $ref: '#/components/examples/access_denied'
                invalid_campaign_controller_id:
                  $ref: '#/components/examples/invalid_campaign_controller_id'
                invalid_controller_action_id:
                  $ref: '#/components/examples/invalid_controller_action_id'
                invalid_controller_trigger_id:
                  $ref: '#/components/examples/invalid_controller_trigger_id'
                method_unauthorized:
                  $ref: '#/components/examples/method_unauthorized'
                missing_access_token:
                  $ref: '#/components/examples/missing_access_token'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Forbidden
        '415':
          content:
            application/json:
              examples:
                unsupported_media_type:
                  $ref: '#/components/examples/unsupported_media_type'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Unsupported Media Type
        '429':
          content:
            application/json:
              examples:
                too_many_requests:
                  $ref: '#/components/examples/too_many_requests'
              schema:
                $ref: '#/components/schemas/RestExceptionResponse'
          description: Too Many Requests
components:
  schemas:
    BuiltCampaignControllerTriggerResponse:
      discriminator:
        mapping:
          ACCESS:
            $ref: '#/components/schemas/BuiltCampaignControllerTriggerAccessResponse'
          AUDIENCE_MEMBERSHIP:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerAudienceMembershipResponse
          AUDIENCE_MEMBERSHIP_EVENT:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerAudienceMembershipEventResponse
          CLIENT_DOMAIN:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerClientDomainResponse
          DATA_INTELLIGENCE_EVENT:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerDataIntelligenceEventResponse
          EVENT:
            $ref: '#/components/schemas/BuiltCampaignControllerTriggerEventResponse'
          EVENT_TARGETING:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerEventTargetingResponse
          EXPRESSION:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerExpressionResponse
          GROUP:
            $ref: '#/components/schemas/BuiltCampaignControllerTriggerGroupResponse'
          HAS_IDENTITY:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerHasIdentityResponse
          HAS_PRIOR_REWARD:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerHasPriorRewardResponse
          HAS_PRIOR_STEP:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerHasPriorStepResponse
          JOURNEY_CHECK:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerJourneyCheckResponse
          LEGACY_LABEL_TARGETING:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerLegacyLabelTargetingResponse
          LEGACY_QUALITY:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerLegacyQualityResponse
          MAXMIND:
            $ref: '#/components/schemas/BuiltCampaignControllerTriggerMaxMindResponse'
          REFERRED_BY_EVENT:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerReferredByEventResponse
          REWARD_EVENT:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerRewardEventResponse
          SCORE:
            $ref: '#/components/schemas/BuiltCampaignControllerTriggerScoreResponse'
          SEND_REWARD_EVENT:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerSendRewardEventResponse
          SHARE:
            $ref: '#/components/schemas/BuiltCampaignControllerTriggerShareResponse'
          STEP_EVENT:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerStepEventResponse
          STICKY_JOURNEY:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerStickyJourneyResponse
          TARGETING:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerTargetingResponse
          ZONE_STATE:
            $ref: >-
              #/components/schemas/BuiltCampaignControllerTriggerZoneStateResponse
        propertyName: trigger_type
      oneOf:
        - title: ACCESS
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerAccessResponse
        - title: AUDIENCE_MEMBERSHIP
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerAudienceMembershipResponse
        - title: AUDIENCE_MEMBERSHIP_EVENT
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerAudienceMembershipEventResponse
        - title: CLIENT_DOMAIN
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerClientDomainResponse
        - title: DATA_INTELLIGENCE_EVENT
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerDataIntelligenceEventResponse
        - title: EVENT
          allOf:
            - $ref: '#/components/schemas/BuiltCampaignControllerTriggerEventResponse'
        - title: EVENT_TARGETING
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerEventTargetingResponse
        - title: EXPRESSION
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerExpressionResponse
        - title: GROUP
          allOf:
            - $ref: '#/components/schemas/BuiltCampaignControllerTriggerGroupResponse'
        - title: HAS_IDENTITY
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerHasIdentityResponse
        - title: HAS_PRIOR_REWARD
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerHasPriorRewardResponse
        - title: HAS_PRIOR_STEP
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerHasPriorStepResponse
        - title: JOURNEY_CHECK
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerJourneyCheckResponse
        - title: LEGACY_LABEL_TARGETING
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerLegacyLabelTargetingResponse
        - title: LEGACY_QUALITY
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerLegacyQualityResponse
        - title: MAXMIND
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerMaxMindResponse
        - title: REFERRED_BY_EVENT
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerReferredByEventResponse
        - title: REWARD_EVENT
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerRewardEventResponse
        - title: SCORE
          allOf:
            - $ref: '#/components/schemas/BuiltCampaignControllerTriggerScoreResponse'
        - title: SEND_REWARD_EVENT
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerSendRewardEventResponse
        - title: SHARE
          allOf:
            - $ref: '#/components/schemas/BuiltCampaignControllerTriggerShareResponse'
        - title: STEP_EVENT
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerStepEventResponse
        - title: STICKY_JOURNEY
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerStickyJourneyResponse
        - title: TARGETING
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerTargetingResponse
        - title: ZONE_STATE
          allOf:
            - $ref: >-
                #/components/schemas/BuiltCampaignControllerTriggerZoneStateResponse
      required:
        - component_ids
        - component_references
        - enabled
        - negated
        - parent_trigger_group_name
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
    RestExceptionResponse:
      description: Represents the API error response
      properties:
        code:
          description: Specific error code for this error type, documented per endpoint
          type: string
        http_status_code:
          description: >-
            HTTP status code that was returned with this error, useful if client
            get response code
          format: int32
          type: integer
        message:
          description: User readable English description of the error
          type: string
        parameters:
          additionalProperties:
            description: >-
              Attributes related to the error, varies be error code, documented
              per endpoint
            type: object
          description: >-
            Attributes related to the error, varies be error code, documented
            per endpoint
          type: object
        unique_id:
          description: >-
            Unique id associated with this error, useful for discussions with
            Extole
          type: string
      required:
        - code
        - http_status_code
        - message
        - parameters
        - unique_id
      type: object
    BuiltCampaignControllerTriggerAccessResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            trigger_type:
              enum:
                - ACCESS
              type: string
            trusted_scopes:
              items:
                enum:
                  - BACKEND
                  - CLIENT_ADMIN
                  - CLIENT_REPORT_DOWNLOAD
                  - CLIENT_SUPERUSER
                  - ONE_TIME
                  - PASSWORD_RESET
                  - UPDATE_PROFILE
                  - USER_SUPPORT
                  - VERIFIED_CONSUMER
                type: string
              type: array
              uniqueItems: true
          type: object
      required:
        - component_ids
        - component_references
        - enabled
        - negated
        - parent_trigger_group_name
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
        - trusted_scopes
      type: object
      title: ACCESS
    BuiltCampaignControllerTriggerAudienceMembershipResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            having_any_audience_id:
              items:
                type: string
              type: array
              uniqueItems: true
            person_id:
              $ref: >-
                #/components/schemas/PersonIdInBuiltCampaignControllerTriggerAudienceMembershipResponse
            trigger_type:
              enum:
                - AUDIENCE_MEMBERSHIP
              type: string
          type: object
      required:
        - component_ids
        - component_references
        - enabled
        - having_any_audience_id
        - negated
        - parent_trigger_group_name
        - person_id
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: AUDIENCE_MEMBERSHIP
    BuiltCampaignControllerTriggerAudienceMembershipEventResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            audience_ids:
              items:
                type: string
              type: array
              uniqueItems: true
            event_types:
              items:
                enum:
                  - CREATED
                  - REMOVED
                  - UPDATED
                type: string
              type: array
              uniqueItems: true
            trigger_type:
              enum:
                - AUDIENCE_MEMBERSHIP_EVENT
              type: string
          type: object
      required:
        - audience_ids
        - component_ids
        - component_references
        - enabled
        - event_types
        - negated
        - parent_trigger_group_name
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: AUDIENCE_MEMBERSHIP_EVENT
    BuiltCampaignControllerTriggerClientDomainResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            client_domain_ids:
              items:
                type: string
              type: array
              uniqueItems: true
            trigger_type:
              enum:
                - CLIENT_DOMAIN
              type: string
          type: object
      required:
        - client_domain_ids
        - component_ids
        - component_references
        - enabled
        - negated
        - parent_trigger_group_name
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: CLIENT_DOMAIN
    BuiltCampaignControllerTriggerDataIntelligenceEventResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            event_name:
              type: string
            trigger_type:
              enum:
                - DATA_INTELLIGENCE_EVENT
              type: string
          type: object
      required:
        - component_ids
        - component_references
        - enabled
        - event_name
        - negated
        - parent_trigger_group_name
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: DATA_INTELLIGENCE_EVENT
    BuiltCampaignControllerTriggerEventResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            event_names:
              items:
                type: string
              type: array
            event_type:
              enum:
                - ASSET
                - DATA_INTELLIGENCE
                - DISPLACED
                - DISPLACED_BY
                - FORWARDED
                - IDENTIFIED
                - INPUT
                - INTERNAL
                - LEGACY_CONSUMER_EVENT
                - MESSAGE
                - MESSAGE_NOT_DELIVERED
                - REFERRED
                - REFERRED_BY
                - SCHEDULED
                - SHARE
                - SHAREABLE
                - STEP
              type: string
            trigger_type:
              enum:
                - EVENT
              type: string
          type: object
      type: object
      title: EVENT
    BuiltCampaignControllerTriggerEventTargetingResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            targeting_attributes:
              additionalProperties:
                type: string
              type: object
            trigger_type:
              enum:
                - EVENT_TARGETING
              type: string
          type: object
      type: object
      title: EVENT_TARGETING
    BuiltCampaignControllerTriggerExpressionResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            data:
              additionalProperties:
                type: string
              type: object
            expression:
              $ref: >-
                #/components/schemas/ExpressionInBuiltCampaignControllerTriggerExpressionResponse
            trigger_type:
              enum:
                - EXPRESSION
              type: string
          type: object
      type: object
      title: EXPRESSION
    BuiltCampaignControllerTriggerGroupResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            operator:
              enum:
                - AND
                - OR
              type: string
            trigger_type:
              enum:
                - GROUP
              type: string
          type: object
      type: object
      title: GROUP
    BuiltCampaignControllerTriggerHasIdentityResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            trigger_type:
              enum:
                - HAS_IDENTITY
              type: string
      required:
        - component_ids
        - component_references
        - enabled
        - negated
        - parent_trigger_group_name
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: HAS_IDENTITY
    BuiltCampaignControllerTriggerHasPriorRewardResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            count_matches:
              items:
                format: int32
                type: integer
              type: array
              uniqueItems: true
            count_max:
              format: int32
              type: integer
            count_min:
              format: int32
              type: integer
            filter_expressions:
              items:
                type: string
              type: array
              uniqueItems: true
            filter_face_value_types:
              items:
                enum:
                  - AUD
                  - BRL
                  - CAD
                  - CNY
                  - EUR
                  - GBP
                  - HKD
                  - INR
                  - JPY
                  - KRW
                  - MONTH
                  - MXN
                  - NZD
                  - PERCENT_OFF
                  - POINTS
                  - TRY
                  - TWD
                  - USD
                type: string
              type: array
              uniqueItems: true
            filter_max_age:
              $ref: '#/components/schemas/Duration'
            filter_max_date:
              $ref: '#/components/schemas/ZonedDateTime'
            filter_min_age:
              $ref: '#/components/schemas/Duration'
            filter_min_date:
              $ref: '#/components/schemas/ZonedDateTime'
            filter_names:
              items:
                type: string
              type: array
              uniqueItems: true
            filter_reward_supplier_ids:
              items:
                type: string
              type: array
              uniqueItems: true
            filter_scope:
              enum:
                - CAMPAIGN
                - CLIENT
                - JOURNEY
                - PROGRAM
              type: string
            filter_states:
              items:
                enum:
                  - CANCELED
                  - EARNED
                  - FAILED
                  - FULFILLED
                  - REDEEMED
                  - REVOKED
                  - SENT
                type: string
              type: array
              uniqueItems: true
            filter_tags:
              items:
                type: string
              type: array
              uniqueItems: true
            sum_of_face_value_max:
              type: number
            sum_of_face_value_min:
              type: number
            tax_year_start:
              $ref: '#/components/schemas/MonthDay'
            trigger_type:
              enum:
                - HAS_PRIOR_REWARD
              type: string
          type: object
      required:
        - component_ids
        - component_references
        - count_matches
        - count_max
        - count_min
        - enabled
        - filter_expressions
        - filter_face_value_types
        - filter_max_age
        - filter_max_date
        - filter_min_age
        - filter_min_date
        - filter_names
        - filter_reward_supplier_ids
        - filter_scope
        - filter_states
        - filter_tags
        - negated
        - parent_trigger_group_name
        - sum_of_face_value_max
        - sum_of_face_value_min
        - tax_year_start
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: HAS_PRIOR_REWARD
    BuiltCampaignControllerTriggerHasPriorStepResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            count_matches:
              items:
                format: int32
                type: integer
              type: array
              uniqueItems: true
            count_max:
              format: int32
              type: integer
            count_min:
              format: int32
              type: integer
            filter_campaign_id:
              type: string
            filter_campaign_ids:
              $ref: >-
                #/components/schemas/FilterCampaignIdsInBuiltCampaignControllerTriggerHasPriorStepResponse
            filter_expression:
              $ref: >-
                #/components/schemas/FilterExpressionInBuiltCampaignControllerTriggerHasPriorStepResponse
            filter_expressions:
              items:
                type: string
              type: array
              uniqueItems: true
            filter_max_age:
              $ref: '#/components/schemas/Duration'
            filter_max_date:
              $ref: '#/components/schemas/ZonedDateTime'
            filter_max_value:
              type: number
            filter_min_age:
              $ref: '#/components/schemas/Duration'
            filter_min_date:
              $ref: '#/components/schemas/ZonedDateTime'
            filter_min_value:
              type: number
            filter_names:
              items:
                type: string
              type: array
              uniqueItems: true
            filter_partner_event_id:
              $ref: '#/components/schemas/PartnerEventId'
            filter_partner_event_id_name:
              type: string
            filter_partner_event_id_value:
              type: string
            filter_program_label:
              type: string
            filter_program_labels:
              $ref: >-
                #/components/schemas/FilterProgramLabelsInBuiltCampaignControllerTriggerHasPriorStepResponse
            filter_quality:
              enum:
                - ANY
                - HIGH
                - LOW
              type: string
            filter_scope:
              enum:
                - ATTRIBUTED
                - CAMPAIGN
                - CLIENT
                - JOURNEY
                - PROGRAM
              type: string
            having_all_names:
              $ref: >-
                #/components/schemas/HavingAllNamesInBuiltCampaignControllerTriggerHasPriorStepResponse
            person_id:
              $ref: >-
                #/components/schemas/PersonIdInBuiltCampaignControllerTriggerHasPriorStepResponse
            sum_of_value_max:
              type: number
            sum_of_value_min:
              type: number
            trigger_type:
              enum:
                - HAS_PRIOR_STEP
              type: string
          type: object
      required:
        - component_ids
        - component_references
        - count_matches
        - count_max
        - count_min
        - enabled
        - filter_campaign_id
        - filter_campaign_ids
        - filter_expression
        - filter_expressions
        - filter_max_age
        - filter_max_date
        - filter_max_value
        - filter_min_age
        - filter_min_date
        - filter_min_value
        - filter_names
        - filter_partner_event_id
        - filter_partner_event_id_name
        - filter_partner_event_id_value
        - filter_program_label
        - filter_program_labels
        - filter_quality
        - filter_scope
        - having_all_names
        - negated
        - parent_trigger_group_name
        - person_id
        - sum_of_value_max
        - sum_of_value_min
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: HAS_PRIOR_STEP
    BuiltCampaignControllerTriggerJourneyCheckResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            journey_name:
              type: string
            person_id:
              $ref: >-
                #/components/schemas/PersonIdInBuiltCampaignControllerTriggerJourneyCheckResponse
            trigger_type:
              enum:
                - JOURNEY_CHECK
              type: string
          type: object
      type: object
      title: JOURNEY_CHECK
    BuiltCampaignControllerTriggerLegacyLabelTargetingResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            trigger_type:
              enum:
                - LEGACY_LABEL_TARGETING
              type: string
      required:
        - component_ids
        - component_references
        - enabled
        - negated
        - parent_trigger_group_name
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: LEGACY_LABEL_TARGETING
    BuiltCampaignControllerTriggerLegacyQualityResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            action_type:
              enum:
                - ANY_CLICK
                - ANY_PROMOTION
                - ANY_PURCHASE
                - ANY_REGISTER
                - ANY_SHARE
                - ANY_SHARE_REWARD
                - GENERIC_ACTION_1
                - GENERIC_ACTION_10
                - GENERIC_ACTION_100
                - GENERIC_ACTION_101
                - GENERIC_ACTION_102
                - GENERIC_ACTION_103
                - GENERIC_ACTION_104
                - GENERIC_ACTION_105
                - GENERIC_ACTION_106
                - GENERIC_ACTION_107
                - GENERIC_ACTION_108
                - GENERIC_ACTION_109
                - GENERIC_ACTION_11
                - GENERIC_ACTION_110
                - GENERIC_ACTION_111
                - GENERIC_ACTION_112
                - GENERIC_ACTION_113
                - GENERIC_ACTION_114
                - GENERIC_ACTION_115
                - GENERIC_ACTION_116
                - GENERIC_ACTION_117
                - GENERIC_ACTION_118
                - GENERIC_ACTION_119
                - GENERIC_ACTION_12
                - GENERIC_ACTION_120
                - GENERIC_ACTION_121
                - GENERIC_ACTION_122
                - GENERIC_ACTION_123
                - GENERIC_ACTION_124
                - GENERIC_ACTION_125
                - GENERIC_ACTION_126
                - GENERIC_ACTION_127
                - GENERIC_ACTION_128
                - GENERIC_ACTION_129
                - GENERIC_ACTION_13
                - GENERIC_ACTION_130
                - GENERIC_ACTION_131
                - GENERIC_ACTION_132
                - GENERIC_ACTION_133
                - GENERIC_ACTION_134
                - GENERIC_ACTION_135
                - GENERIC_ACTION_136
                - GENERIC_ACTION_137
                - GENERIC_ACTION_138
                - GENERIC_ACTION_139
                - GENERIC_ACTION_14
                - GENERIC_ACTION_140
                - GENERIC_ACTION_141
                - GENERIC_ACTION_142
                - GENERIC_ACTION_143
                - GENERIC_ACTION_144
                - GENERIC_ACTION_145
                - GENERIC_ACTION_146
                - GENERIC_ACTION_147
                - GENERIC_ACTION_148
                - GENERIC_ACTION_149
                - GENERIC_ACTION_15
                - GENERIC_ACTION_150
                - GENERIC_ACTION_151
                - GENERIC_ACTION_152
                - GENERIC_ACTION_153
                - GENERIC_ACTION_154
                - GENERIC_ACTION_155
                - GENERIC_ACTION_156
                - GENERIC_ACTION_157
                - GENERIC_ACTION_158
                - GENERIC_ACTION_159
                - GENERIC_ACTION_16
                - GENERIC_ACTION_160
                - GENERIC_ACTION_161
                - GENERIC_ACTION_162
                - GENERIC_ACTION_163
                - GENERIC_ACTION_164
                - GENERIC_ACTION_165
                - GENERIC_ACTION_166
                - GENERIC_ACTION_167
                - GENERIC_ACTION_168
                - GENERIC_ACTION_169
                - GENERIC_ACTION_17
                - GENERIC_ACTION_170
                - GENERIC_ACTION_171
                - GENERIC_ACTION_172
                - GENERIC_ACTION_173
                - GENERIC_ACTION_174
                - GENERIC_ACTION_175
                - GENERIC_ACTION_176
                - GENERIC_ACTION_177
                - GENERIC_ACTION_178
                - GENERIC_ACTION_179
                - GENERIC_ACTION_18
                - GENERIC_ACTION_180
                - GENERIC_ACTION_181
                - GENERIC_ACTION_182
                - GENERIC_ACTION_183
                - GENERIC_ACTION_184
                - GENERIC_ACTION_185
                - GENERIC_ACTION_186
                - GENERIC_ACTION_187
                - GENERIC_ACTION_188
                - GENERIC_ACTION_189
                - GENERIC_ACTION_19
                - GENERIC_ACTION_190
                - GENERIC_ACTION_191
                - GENERIC_ACTION_192
                - GENERIC_ACTION_193
                - GENERIC_ACTION_194
                - GENERIC_ACTION_195
                - GENERIC_ACTION_196
                - GENERIC_ACTION_197
                - GENERIC_ACTION_198
                - GENERIC_ACTION_199
                - GENERIC_ACTION_2
                - GENERIC_ACTION_20
                - GENERIC_ACTION_200
                - GENERIC_ACTION_21
                - GENERIC_ACTION_22
                - GENERIC_ACTION_23
                - GENERIC_ACTION_24
                - GENERIC_ACTION_25
                - GENERIC_ACTION_26
                - GENERIC_ACTION_27
                - GENERIC_ACTION_28
                - GENERIC_ACTION_29
                - GENERIC_ACTION_3
                - GENERIC_ACTION_30
                - GENERIC_ACTION_31
                - GENERIC_ACTION_32
                - GENERIC_ACTION_33
                - GENERIC_ACTION_34
                - GENERIC_ACTION_35
                - GENERIC_ACTION_36
                - GENERIC_ACTION_37
                - GENERIC_ACTION_38
                - GENERIC_ACTION_39
                - GENERIC_ACTION_4
                - GENERIC_ACTION_40
                - GENERIC_ACTION_41
                - GENERIC_ACTION_42
                - GENERIC_ACTION_43
                - GENERIC_ACTION_44
                - GENERIC_ACTION_45
                - GENERIC_ACTION_46
                - GENERIC_ACTION_47
                - GENERIC_ACTION_48
                - GENERIC_ACTION_49
                - GENERIC_ACTION_5
                - GENERIC_ACTION_50
                - GENERIC_ACTION_51
                - GENERIC_ACTION_52
                - GENERIC_ACTION_53
                - GENERIC_ACTION_54
                - GENERIC_ACTION_55
                - GENERIC_ACTION_56
                - GENERIC_ACTION_57
                - GENERIC_ACTION_58
                - GENERIC_ACTION_59
                - GENERIC_ACTION_6
                - GENERIC_ACTION_60
                - GENERIC_ACTION_61
                - GENERIC_ACTION_62
                - GENERIC_ACTION_63
                - GENERIC_ACTION_64
                - GENERIC_ACTION_65
                - GENERIC_ACTION_66
                - GENERIC_ACTION_67
                - GENERIC_ACTION_68
                - GENERIC_ACTION_69
                - GENERIC_ACTION_7
                - GENERIC_ACTION_70
                - GENERIC_ACTION_71
                - GENERIC_ACTION_72
                - GENERIC_ACTION_73
                - GENERIC_ACTION_74
                - GENERIC_ACTION_75
                - GENERIC_ACTION_76
                - GENERIC_ACTION_77
                - GENERIC_ACTION_78
                - GENERIC_ACTION_79
                - GENERIC_ACTION_8
                - GENERIC_ACTION_80
                - GENERIC_ACTION_81
                - GENERIC_ACTION_82
                - GENERIC_ACTION_83
                - GENERIC_ACTION_84
                - GENERIC_ACTION_85
                - GENERIC_ACTION_86
                - GENERIC_ACTION_87
                - GENERIC_ACTION_88
                - GENERIC_ACTION_89
                - GENERIC_ACTION_9
                - GENERIC_ACTION_90
                - GENERIC_ACTION_91
                - GENERIC_ACTION_92
                - GENERIC_ACTION_93
                - GENERIC_ACTION_94
                - GENERIC_ACTION_95
                - GENERIC_ACTION_96
                - GENERIC_ACTION_97
                - GENERIC_ACTION_98
                - GENERIC_ACTION_99
                - THEME_GENERIC_ACTION_1
                - THEME_GENERIC_ACTION_10
                - THEME_GENERIC_ACTION_11
                - THEME_GENERIC_ACTION_12
                - THEME_GENERIC_ACTION_13
                - THEME_GENERIC_ACTION_14
                - THEME_GENERIC_ACTION_15
                - THEME_GENERIC_ACTION_16
                - THEME_GENERIC_ACTION_17
                - THEME_GENERIC_ACTION_18
                - THEME_GENERIC_ACTION_19
                - THEME_GENERIC_ACTION_2
                - THEME_GENERIC_ACTION_20
                - THEME_GENERIC_ACTION_21
                - THEME_GENERIC_ACTION_22
                - THEME_GENERIC_ACTION_23
                - THEME_GENERIC_ACTION_24
                - THEME_GENERIC_ACTION_25
                - THEME_GENERIC_ACTION_26
                - THEME_GENERIC_ACTION_27
                - THEME_GENERIC_ACTION_28
                - THEME_GENERIC_ACTION_29
                - THEME_GENERIC_ACTION_3
                - THEME_GENERIC_ACTION_30
                - THEME_GENERIC_ACTION_4
                - THEME_GENERIC_ACTION_5
                - THEME_GENERIC_ACTION_6
                - THEME_GENERIC_ACTION_7
                - THEME_GENERIC_ACTION_8
                - THEME_GENERIC_ACTION_9
              type: string
            trigger_type:
              enum:
                - LEGACY_QUALITY
              type: string
          type: object
      type: object
      title: LEGACY_QUALITY
    BuiltCampaignControllerTriggerMaxMindResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            allow_high_risk_email:
              type: boolean
            default_quality_score:
              enum:
                - ERROR
                - HIGH
                - LOW
              type: string
            ip_threshold:
              format: int64
              type: integer
            risk_threshold:
              format: int64
              type: integer
            trigger_type:
              enum:
                - MAXMIND
              type: string
          type: object
      required:
        - allow_high_risk_email
        - component_ids
        - component_references
        - default_quality_score
        - enabled
        - ip_threshold
        - negated
        - parent_trigger_group_name
        - risk_threshold
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: MAXMIND
    BuiltCampaignControllerTriggerReferredByEventResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            referral_originator:
              enum:
                - ADVOCATE
                - FRIEND
              nullable: true
              type: string
            trigger_type:
              enum:
                - REFERRED_BY_EVENT
              type: string
          type: object
      required:
        - component_ids
        - component_references
        - enabled
        - negated
        - parent_trigger_group_name
        - referral_originator
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: REFERRED_BY_EVENT
    BuiltCampaignControllerTriggerRewardEventResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            event_names:
              items:
                type: string
              type: array
              uniqueItems: true
            reward_states:
              items:
                enum:
                  - CANCELED
                  - EARNED
                  - FAILED
                  - FULFILLED
                  - REDEEMED
                  - REVOKED
                type: string
              type: array
              uniqueItems: true
            slots:
              items:
                type: string
              type: array
              uniqueItems: true
            tags:
              items:
                type: string
              type: array
              uniqueItems: true
            trigger_type:
              enum:
                - REWARD_EVENT
              type: string
          type: object
      required:
        - component_ids
        - component_references
        - enabled
        - event_names
        - negated
        - parent_trigger_group_name
        - reward_states
        - slots
        - tags
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: REWARD_EVENT
    BuiltCampaignControllerTriggerScoreResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            cause_event_name:
              type: string
            channel:
              type: string
            score_result:
              type: string
            trigger_type:
              enum:
                - SCORE
              type: string
          type: object
      required:
        - cause_event_name
        - channel
        - component_ids
        - component_references
        - enabled
        - negated
        - parent_trigger_group_name
        - score_result
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: SCORE
    BuiltCampaignControllerTriggerSendRewardEventResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            reward_names:
              items:
                type: string
              type: array
              uniqueItems: true
            reward_states:
              items:
                enum:
                  - FULFILLED
                  - SENT
                type: string
              type: array
              uniqueItems: true
            tags:
              items:
                type: string
              type: array
              uniqueItems: true
            trigger_type:
              enum:
                - SEND_REWARD_EVENT
              type: string
          type: object
      required:
        - component_ids
        - component_references
        - enabled
        - negated
        - parent_trigger_group_name
        - reward_names
        - reward_states
        - tags
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: SEND_REWARD_EVENT
    BuiltCampaignControllerTriggerShareResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            channels:
              items:
                enum:
                  - ANY
                  - EMAIL
                  - EXTOLE_EMAIL
                  - EXTOLE_TWITTER
                  - FACEBOOK
                  - TWITTER
                type: string
              type: array
              uniqueItems: true
            quality:
              enum:
                - ANY
                - HIGH
                - LOW
              type: string
            share_types:
              items:
                enum:
                  - ANY
                  - EMAIL
                  - EXTOLE_EMAIL
                  - EXTOLE_TWITTER
                  - FACEBOOK
                  - TWITTER
                type: string
              type: array
              uniqueItems: true
              writeOnly: true
            trigger_type:
              enum:
                - SHARE
              type: string
          type: object
      required:
        - channels
        - component_ids
        - component_references
        - enabled
        - negated
        - parent_trigger_group_name
        - quality
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
      type: object
      title: SHARE
    BuiltCampaignControllerTriggerStepEventResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            event_names:
              items:
                type: string
              type: array
              uniqueItems: true
            having_any_data_name:
              items:
                type: string
              type: array
              uniqueItems: true
            trigger_type:
              enum:
                - STEP_EVENT
              type: string
          type: object
      type: object
      title: STEP_EVENT
    BuiltCampaignControllerTriggerStickyJourneyResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            label:
              type: string
            trigger_type:
              enum:
                - STICKY_JOURNEY
              type: string
          type: object
      type: object
      title: STICKY_JOURNEY
    BuiltCampaignControllerTriggerTargetingResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            scope:
              enum:
                - CAMPAIGN
                - JOURNEY
                - PROGRAM
              type: string
            trigger_type:
              enum:
                - TARGETING
              type: string
          type: object
      type: object
      title: TARGETING
    BuiltCampaignControllerTriggerZoneStateResponse:
      allOf:
        - $ref: '#/components/schemas/BuiltCampaignControllerTriggerResponseBase'
        - properties:
            invert_mapping_state:
              type: boolean
            step_name:
              nullable: true
              type: string
            trigger_type:
              enum:
                - ZONE_STATE
              type: string
            zone_name:
              nullable: true
              type: string
          type: object
      required:
        - component_ids
        - component_references
        - enabled
        - invert_mapping_state
        - negated
        - parent_trigger_group_name
        - step_name
        - trigger_description
        - trigger_id
        - trigger_name
        - trigger_phase
        - trigger_type
        - zone_name
      type: object
      title: ZONE_STATE
    BuiltCampaignControllerTriggerResponseBase:
      properties:
        component_ids:
          items:
            type: string
          type: array
        component_references:
          items:
            $ref: '#/components/schemas/ComponentReferenceResponse'
          type: array
        enabled:
          type: boolean
        negated:
          type: boolean
        parent_trigger_group_name:
          type: string
        trigger_description:
          type: string
        trigger_id:
          type: string
        trigger_name:
          type: string
        trigger_phase:
          enum:
            - MATCHING
            - QUALIFYING
            - QUALITY
          type: string
        trigger_type:
          enum:
            - ACCESS
            - AUDIENCE_MEMBERSHIP
            - AUDIENCE_MEMBERSHIP_EVENT
            - CLIENT_DOMAIN
            - DATA_INTELLIGENCE_EVENT
            - EVENT
            - EVENT_TARGETING
            - EXPRESSION
            - GROUP
            - HAS_IDENTITY
            - HAS_PRIOR_REWARD
            - HAS_PRIOR_STEP
            - JOURNEY_CHECK
            - LEGACY_LABEL_TARGETING
            - LEGACY_QUALITY
            - MAXMIND
            - REFERRED_BY_EVENT
            - REWARD_EVENT
            - SCORE
            - SEND_REWARD_EVENT
            - SHARE
            - STEP_EVENT
            - STICKY_JOURNEY
            - TARGETING
            - ZONE_STATE
          type: string
      type: object
    PersonIdInBuiltCampaignControllerTriggerAudienceMembershipResponse:
      description: >-
        The person id as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal person id
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [AudienceMembershipTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/audience/membership/AudienceMembershipTriggerContext.d.ts).
          example: handlebars@runtime:{{personId}}
          externalDocs:
            description: AudienceMembershipTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/audience/membership/AudienceMembershipTriggerContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [AudienceMembershipTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/audience/membership/AudienceMembershipTriggerContext.d.ts).
          example: javascript@runtime:function() { return context.get('personId');}
          externalDocs:
            description: AudienceMembershipTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/audience/membership/AudienceMembershipTriggerContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    ExpressionInBuiltCampaignControllerTriggerExpressionResponse:
      description: >-
        The expression as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal expression
          title: Static Value
          type: boolean
        - description: >-
            Handlebars expression with
            [ExpressionTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/expression/ExpressionTriggerContext.d.ts).
          example: handlebars@runtime:{{expression}}
          externalDocs:
            description: ExpressionTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/expression/ExpressionTriggerContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [ExpressionTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/expression/ExpressionTriggerContext.d.ts).
          example: javascript@runtime:function() { return context.get('expression');}
          externalDocs:
            description: ExpressionTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/expression/ExpressionTriggerContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    Duration:
      description: >-
        [RFC 5545](https://datatracker.ietf.org/doc/html/rfc5545#section-3.3.6)
        duration string.
      example: PT42S
      pattern: >-
        ^[-+]?P(?:(?:[-+]?[0-9]+D)(?:T(?=(?:[-+]?[0-9]+H|[-+]?[0-9]+M|[-+]?[0-9]+(?:[.,][0-9]*)?S))(?:[-+]?[0-9]+H)?(?:[-+]?[0-9]+M)?(?:[-+]?[0-9]+(?:[.,][0-9]*)?S)?)?|T(?=(?:[-+]?[0-9]+H|[-+]?[0-9]+M|[-+]?[0-9]+(?:[.,][0-9]*)?S))(?:[-+]?[0-9]+H)?(?:[-+]?[0-9]+M)?(?:[-+]?[0-9]+(?:[.,][0-9]*)?S)?)$
      type: string
    ZonedDateTime:
      description: >-
        [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339#section-5.6) or
        [RFC 9557](https://datatracker.ietf.org/doc/html/rfc9557#section-4)
        date-time with a numeric [UTC
        offset](https://datatracker.ietf.org/doc/html/rfc3339#section-5.6) and
        an optional [IANA
        time-zone](https://datatracker.ietf.org/doc/html/rfc9557#section-4)
        suffix in square brackets. Precision up to milliseconds.
      example: '2025-10-24T02:00:00-07:00'
      pattern: >-
        ^\d{4}-\d{2}-\d{2}T\d{2}:\d{2}:\d{2}(\.\d{1,3})?(Z|[+-](?:[01][0-9]|2[0-3]):[0-5][0-9])(\[[^\]]+\])?$
      type: string
    MonthDay:
      description: >-
        [RFC 3339](https://datatracker.ietf.org/doc/html/rfc3339#appendix-A)
        month-day date.
      example: '--10-24'
      pattern: ^--(0[1-9]|1[0-2])-(0[1-9]|[12][0-9]|3[01])$
      type: string
    FilterCampaignIdsInBuiltCampaignControllerTriggerHasPriorStepResponse:
      description: >-
        The filter campaign ids as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal filter campaign ids
          items:
            type: string
          title: Static Value
          type: array
          uniqueItems: true
        - description: >-
            Handlebars expression with
            [HasPriorStepTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts).
          example: handlebars@runtime:{{filterCampaignIds}}
          externalDocs:
            description: HasPriorStepTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [HasPriorStepTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts).
          example: >-
            javascript@runtime:function() { return
            context.get('filterCampaignIds');}
          externalDocs:
            description: HasPriorStepTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    FilterExpressionInBuiltCampaignControllerTriggerHasPriorStepResponse:
      description: >-
        The filter expression as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal filter expression
          title: Static Value
          type: boolean
        - description: >-
            Handlebars expression with
            [StepHasPriorStepTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/StepHasPriorStepTriggerContext.d.ts).
          example: handlebars@runtime:{{filterExpression}}
          externalDocs:
            description: StepHasPriorStepTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/StepHasPriorStepTriggerContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [StepHasPriorStepTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/StepHasPriorStepTriggerContext.d.ts).
          example: >-
            javascript@runtime:function() { return
            context.get('filterExpression');}
          externalDocs:
            description: StepHasPriorStepTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/StepHasPriorStepTriggerContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    PartnerEventId:
      properties:
        name:
          type: string
        value:
          type: string
      type: object
    FilterProgramLabelsInBuiltCampaignControllerTriggerHasPriorStepResponse:
      description: >-
        The filter program labels as configured: a literal value, or an
        expression (type:string) when defined dynamically.
      oneOf:
        - description: Literal filter program labels
          items:
            type: string
          title: Static Value
          type: array
          uniqueItems: true
        - description: >-
            Handlebars expression with
            [HasPriorStepTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts).
          example: handlebars@runtime:{{filterProgramLabels}}
          externalDocs:
            description: HasPriorStepTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [HasPriorStepTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts).
          example: >-
            javascript@runtime:function() { return
            context.get('filterProgramLabels');}
          externalDocs:
            description: HasPriorStepTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    HavingAllNamesInBuiltCampaignControllerTriggerHasPriorStepResponse:
      description: >-
        The having all names as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal having all names
          items:
            type: string
          title: Static Value
          type: array
          uniqueItems: true
        - description: >-
            Handlebars expression with
            [HasPriorStepTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts).
          example: handlebars@runtime:{{havingAllNames}}
          externalDocs:
            description: HasPriorStepTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [HasPriorStepTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts).
          example: >-
            javascript@runtime:function() { return
            context.get('havingAllNames');}
          externalDocs:
            description: HasPriorStepTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    PersonIdInBuiltCampaignControllerTriggerHasPriorStepResponse:
      description: >-
        The person id as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal person id
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [HasPriorStepTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts).
          example: handlebars@runtime:{{personId}}
          externalDocs:
            description: HasPriorStepTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [HasPriorStepTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts).
          example: javascript@runtime:function() { return context.get('personId');}
          externalDocs:
            description: HasPriorStepTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/has/prior/step/HasPriorStepTriggerContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    PersonIdInBuiltCampaignControllerTriggerJourneyCheckResponse:
      description: >-
        The person id as configured: a literal value, or an expression
        (type:string) when defined dynamically.
      oneOf:
        - description: Literal person id
          title: Static Value
          type: string
        - description: >-
            Handlebars expression with
            [StepTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/StepTriggerContext.d.ts).
          example: handlebars@runtime:{{personId}}
          externalDocs:
            description: StepTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/StepTriggerContext.d.ts
          pattern: ^handlebars@runtime:.*
          title: Runtime - Handlebars
          type: string
        - description: >-
            Javascript expression with
            [StepTriggerContext](https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/StepTriggerContext.d.ts).
          example: javascript@runtime:function() { return context.get('personId');}
          externalDocs:
            description: StepTriggerContext
            url: >-
              https://github.com/extole/extole-specification/blob/main/openapi/expression-context/com/extole/api/trigger/StepTriggerContext.d.ts
          pattern: ^javascript@runtime:.*
          title: Runtime - Javascript
          type: string
    ComponentReferenceResponse:
      properties:
        component_id:
          type: string
        socket_names:
          items:
            type: string
          type: array
      type: object
  examples:
    binding_error:
      summary: binding_error
      value:
        code: binding_error
        http_status_code: 400
        message: Argument is not of the expected type
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_build_failed:
      summary: campaign_build_failed
      value:
        code: campaign_build_failed
        http_status_code: 400
        message: Campaign build failed
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_concurrent_update:
      summary: campaign_concurrent_update
      value:
        code: campaign_concurrent_update
        http_status_code: 400
        message: >-
          Could not perform the operation. Campaign is currently updated by
          other process/user
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_has_pending_changes:
      summary: campaign_has_pending_changes
      value:
        code: campaign_has_pending_changes
        http_status_code: 400
        message: Could not perform the operation. Campaign has pending changes
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_locked:
      summary: campaign_locked
      value:
        code: campaign_locked
        http_status_code: 400
        message: Could not perform the operation. The campaign is locked
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    campaign_version_malformed:
      summary: campaign_version_malformed
      value:
        code: campaign_version_malformed
        http_status_code: 400
        message: Campaign version is malformed
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    controller_state_misconfiguration:
      summary: controller_state_misconfiguration
      value:
        code: controller_state_misconfiguration
        http_status_code: 400
        message: A controller has not properly configured state
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    date_invalid:
      summary: date_invalid
      value:
        code: date_invalid
        http_status_code: 400
        message: Date is invalid or not ISO-8601 compliant
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    expression_invalid_syntax:
      summary: expression_invalid_syntax
      value:
        code: expression_invalid_syntax
        http_status_code: 400
        message: Campaign build failed due expression invalid syntax
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_campaign_id:
      summary: invalid_campaign_id
      value:
        code: invalid_campaign_id
        http_status_code: 400
        message: Invalid Campaign Id
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_campaign_state:
      summary: invalid_campaign_state
      value:
        code: invalid_campaign_state
        http_status_code: 400
        message: Invalid campaign state
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_campaign_version:
      summary: invalid_campaign_version
      value:
        code: invalid_campaign_version
        http_status_code: 400
        message: Invalid Campaign Version
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_json:
      summary: invalid_json
      value:
        code: invalid_json
        http_status_code: 400
        message: JSON is invalid
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_parameter:
      summary: invalid_parameter
      value:
        code: invalid_parameter
        http_status_code: 400
        message: Parameter is invalid.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    lock_missing_lock_types:
      summary: lock_missing_lock_types
      value:
        code: lock_missing_lock_types
        http_status_code: 400
        message: Unable to unlock, lock types should be specified
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    missing_request_body:
      summary: missing_request_body
      value:
        code: missing_request_body
        http_status_code: 400
        message: Missing request body
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    rebuild_campaigns_build_failed:
      summary: rebuild_campaigns_build_failed
      value:
        code: rebuild_campaigns_build_failed
        http_status_code: 400
        message: Rebuild campaigns build failed
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    unlock_missing_lock_types:
      summary: unlock_missing_lock_types
      value:
        code: unlock_missing_lock_types
        http_status_code: 400
        message: Unable to lock, lock types should be specified
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    method_unauthorized:
      summary: method_unauthorized
      value:
        code: method_unauthorized
        http_status_code: 401
        message: Unauthorized access to this endpoint
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    payment_required:
      summary: payment_required
      value:
        code: payment_required
        http_status_code: 402
        message: The access_token provided is associated with an unpaid account.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    access_denied:
      summary: access_denied
      value:
        code: access_denied
        http_status_code: 403
        message: >-
          The access_token provided is not permitted to access the specified
          resource.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_campaign_controller_id:
      summary: invalid_campaign_controller_id
      value:
        code: invalid_campaign_controller_id
        http_status_code: 403
        message: Invalid campaign controller id
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_controller_action_id:
      summary: invalid_controller_action_id
      value:
        code: invalid_controller_action_id
        http_status_code: 403
        message: Invalid campaign controller action id
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    invalid_controller_trigger_id:
      summary: invalid_controller_trigger_id
      value:
        code: invalid_controller_trigger_id
        http_status_code: 403
        message: Invalid campaign controller trigger id
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    missing_access_token:
      summary: missing_access_token
      value:
        code: missing_access_token
        http_status_code: 403
        message: No access_token was provided with this request.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    unsupported_media_type:
      summary: unsupported_media_type
      value:
        code: unsupported_media_type
        http_status_code: 415
        message: Request had an unsupported or no media type
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
    too_many_requests:
      summary: too_many_requests
      value:
        code: too_many_requests
        http_status_code: 429
        message: >-
          The server is unable to process your request at the moment, please
          retry later.
        parameters: {}
        unique_id: 00000000-0000-0000-0000-000000000000
  securitySchemes:
    HEADER:
      in: header
      name: Authorization
      type: apiKey
      x-bearer-format: bearer
    QUERY:
      in: query
      name: access_token
      type: apiKey
    COOKIE:
      in: cookie
      name: extole_token
      type: apiKey

````